.include "m128def.inc"


.equ CLOCK = 3686000
.equ BAUD = 115200
.equ UBRRVAL = CLOCK/(BAUD*16)-1

.def temp = r16
.def flags = r18

.org 0x00
rjmp reset
.org ADCCaddr
rjmp ADCC_i

ADCC_i:
push temp
in temp,SREG
push temp

in r17,ADCH
sbr flags,1


pop temp
out SREG,temp
pop temp
reti


reset:
ldi temp,HIGH(RAMEND)
out SPH,temp

ldi temp,LOW(RAMEND)
out SPL,temp

ldi temp,0xFF
out DDRE,temp

ldi temp, 1;LOW(UBRRVAL)
out UBRR0L, temp
ldi temp, 0;HIGH(UBRRVAL)
sts UBRR0H, temp
 
  ldi temp, 0b00011000
  out UCSR0B,temp

  ldi temp, 0b00000110
  sts UCSR0C,temp

sbi ADCSRA,ADEN

ldi temp,0b00100000
out ADMUX,temp

ldi temp,0b11101100
out ADCSRA,temp

sei

main:
sbrc flags,0
rcall serout
rjmp main

serout:
        sbis UCSR0A,UDRE0                   ; Warten bis UDR fr das nchste
                                          ; Byte bereit ist
        rjmp serout
      	out UDR0, r17
		cbr flags,1
		cbi ADCSRA,ADIF
        ret                               ; zurck zum Hauptprogramm 

